Bug 1118232 - ghc-glib ftbfs on aarch64
Summary: ghc-glib ftbfs on aarch64
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: gtk2hs-buildtools
Version: 21
Hardware: aarch64
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Jens Petersen
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: ARM64, F-ExcludeArch-aarch64 1288611
TreeView+ depends on / blocked
 
Reported: 2014-07-10 09:06 UTC by Peter Robinson
Modified: 2015-12-04 17:58 UTC (History)
2 users (show)

Fixed In Version: gtk2hs-buildtools-0.13.0.1-1.fc21
Doc Type: Bug Fix
Doc Text:
Clone Of:
: 1288611 (view as bug list)
Environment:
Last Closed: 2014-11-01 17:08:59 UTC


Attachments (Terms of Use)

Description Peter Robinson 2014-07-10 09:06:58 UTC
ghc-glib-0.12.5.0-1.fc21 is ftbfs on aarch64

http://arm.koji.fedoraproject.org/koji/taskinfo?taskID=2485540


++ ghc --info
++ grep '"Booter version","7.6.3"'
+ '[' '!' ' ,("Booter version","7.6.3")' ']'
+ '[' -x Setup ']'
+ ghc --make -no-user-package-db Setup
[1 of 2] Compiling SetupWrapper     ( SetupWrapper.hs, SetupWrapper.o )
[2 of 2] Compiling Main             ( Setup.hs, Setup.o )
Linking Setup ...
+ ./Setup configure --prefix=/usr --libdir=/usr/lib64 --docdir=/usr/share/doc/ghc-glib '--libsubdir=$compiler/$pkgid' '--datasubdir=$pkgid' --ghc --ghc-option=-O2 -p --htmldir=/usr/share/doc/ghc/html/libraries/glib --global
[1 of 2] Compiling Gtk2HsSetup      ( Gtk2HsSetup.hs, dist/setup-wrapper/Gtk2HsSetup.o )
[2 of 2] Compiling Main             ( SetupMain.hs, dist/setup-wrapper/Main.o )
Linking dist/setup-wrapper/setup ...
Configuring glib-0.12.5.0...
+ '[' -x Setup ']'
+ ./Setup build
Building glib-0.12.5.0...
Preprocessing library glib-0.12.5.0...
gtk2hsC2hs: Error in C header file.
/usr/include/asm/sigcontext.h:53: (column 2) [FATAL] 
  >>> Syntax error!
  The symbol `__uint128_t' does not fit here.
error: Bad exit status from /var/tmp/rpm-tmp.YQQi78 (%build)
    Bad exit status from /var/tmp/rpm-tmp.YQQi78 (%build)
RPM build errors:

Comment 1 Jens Petersen 2014-10-01 03:53:43 UTC
I started looking at this: here is where the error occurs:

$ LANG=en_US.utf8 ./Setup build -v
creating dist/build
creating dist/build/autogen
Building glib-0.12.5.0...
Preprocessing library glib-0.12.5.0...
creating dist/build/System/Glib
/usr/bin/gtk2hsC2hs --include=dist/build --include=/usr/lib64/ghc-7.6.3/base-4.6.0.1 --include=/usr/lib64/ghc-7.6.3/containers-0.5.0.0 --include=/usr/lib64/ghc-7.6.3/utf8-string-0.3.7 --cpp=/usr/bin/gcc --cppopts=-E --cppopts=-Idist/build/autogen --cppopts=-Idist/build --cppopts=-ISystem/Glib --cppopts=-I/usr/include/glib-2.0 --cppopts=-I/usr/lib64/glib-2.0/include --cppopts=-DUSE_GCLOSURE_SIGNALS_IMPL --cppopts=-D__GLASGOW_HASKELL__=706 --output-dir=dist/build/System/Glib/ --output=GError.hs --precomp=dist/build/precompchs.bin glib-object.h ./System/Glib/GError.chs
gtk2hsC2hs: Error in C header file.

/usr/include/asm/sigcontext.h:53: (column 2) [FATAL]
  >>> Syntax error!
  The symbol `__uint128_t' does not fit here.

I may try to see if things are better under ghc-7.8 before investigating further...

Comment 2 Peter Robinson 2014-10-01 16:56:34 UTC
> I may try to see if things are better under ghc-7.8 before investigating
> further...

Is 7.8 going to land in F-21?

Comment 3 Jens Petersen 2014-10-02 02:34:07 UTC
(In reply to Peter Robinson from comment #2)
> > I may try to see if things are better under ghc-7.8 before investigating
> > further...
> 
> Is 7.8 going to land in F-21?

It was originally planned but we're behind schedule
so I don't think so at this point.

Comment 4 Peter Robinson 2014-10-02 09:09:02 UTC
(In reply to Jens Petersen from comment #3)
> (In reply to Peter Robinson from comment #2)
> > > I may try to see if things are better under ghc-7.8 before investigating
> > > further...
> > 
> > Is 7.8 going to land in F-21?
> 
> It was originally planned but we're behind schedule
> so I don't think so at this point.

Can we investigate the issue further then? We need this fixed in F-21 too

Comment 5 Jens Petersen 2014-10-03 02:51:14 UTC
(In reply to Peter Robinson from comment #4)
> Can we investigate the issue further then? We need this fixed in F-21 too

Yes, I plan to, but first I was to know if it is fixed with latest
ghc and ghc-glib etc.  The problem seems related to preprocessing
of the headers and looks tricky to me.

Unfortunately getting ghc-7.8.3 to build with arm64 also seems non-trivial
so more fun in the pipeline... ;o)

Comment 6 Jens Petersen 2014-10-08 08:56:33 UTC
Okay, I took the long scenic route, and have confirmed that Haskell glib builds okay
on aarch64 with newer gtk2hs-buildtools.

Comment 7 Fedora Update System 2014-10-10 03:39:14 UTC
gtk2hs-buildtools-0.13.0.1-1.fc21 has been submitted as an update for Fedora 21.
https://admin.fedoraproject.org/updates/gtk2hs-buildtools-0.13.0.1-1.fc21

Comment 8 Fedora Update System 2014-10-11 07:02:48 UTC
Package gtk2hs-buildtools-0.13.0.1-1.fc21:
* should fix your issue,
* was pushed to the Fedora 21 testing repository,
* should be available at your local mirror within two days.
Update it with:
# su -c 'yum update --enablerepo=updates-testing gtk2hs-buildtools-0.13.0.1-1.fc21'
as soon as you are able to.
Please go to the following url:
https://admin.fedoraproject.org/updates/FEDORA-2014-12669/gtk2hs-buildtools-0.13.0.1-1.fc21
then log in and leave karma (feedback).

Comment 9 Fedora Update System 2014-11-01 17:08:59 UTC
gtk2hs-buildtools-0.13.0.1-1.fc21 has been pushed to the Fedora 21 stable repository.  If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.